package transportgrpc

import (
	"git.perx.ru/perxis/perxis-go/images"
	"git.perx.ru/perxis/perxis-go/images/transport"
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	pb "git.perx.ru/perxis/perxis-go/proto/images"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc images.Images, opts ...grpckit.ServerOption) pb.ImagesServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		GetEndpoint: grpcerr.ServerMiddleware(eps.GetEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
